#include <iostream>
#include "osztalyok.hpp"
#include "library\seqinfileenumerator.hpp"

//Feladat:
//Adott egy szekvencilis input fjl, meteorolgiai adatatokat tartalmaz:
//dtum, napi max, napi csap
//Mennyi az els csapadkos szakaszban a legalacsonyabb hmrsklet?
//Feltehet, hogy legalbb egy csapadkos nap van.

using namespace std;


int main()
{
    cout << "Megkezdett felsorolo folytatasa pelda" << endl;
    string fname;
    cout<<"Add meg az adatokat tartalmazo fajl nevet:"; cin>>fname;
    try{
        ElsoCsapadekos pr1;
        SeqInFileEnumerator<adat> enor(fname);
        pr1.addEnumerator(&enor);
        pr1.run();
        adat akt=pr1.result();
        cout<<"Elso csapadekos nap:"<<akt.date<<endl;
        MinHom pr2;
        pr2.addEnumerator(&enor);
        pr2.run();
        int minhom=pr2.opt(); string mindate=pr2.optElem().date;
        cout<<"Legalacsonyabb homerseklet az elso csapadekos szakaszban: "<<minhom<<" datuma: "<<mindate<<endl;
    }catch(...)
    {
        cerr<<"Problema van az "<<fname<<" fajllal!\n";
    }
    return 0;
}

//Ha nem biztos, hogy volt csapadekos nap, hogyan oldhat meg?
/*
int main()
{
    cout << "Megkezdett felsorolo folytatasa pelda" << endl;
    string fname;
    cout<<"Add meg az adatokat tartalmazo fajl nevet:"; cin>>fname;
    try{
        ElsoCsapadekos_lehet_hogy_nincs pr1;
        SeqInFileEnumerator<adat> enor(fname);
        pr1.addEnumerator(&enor);
        pr1.run();
        if(enor.end())
        {
            cout<<"Nem volt csapadekos nap!\n";
        }else{
            adat akt=pr1.result();
            cout<<"Elso csapadekos nap:"<<akt.date<<endl;
            MinHom pr2;
            pr2.addEnumerator(&enor);
            pr2.run();
            int minhom=pr2.opt(); string mindate=pr2.optElem().date;
            cout<<"Legalacsonyabb homerseklet az elso csapadekos szakaszban: "<<minhom<<" datuma: "<<mindate<<endl;
        }
    }catch(...)
    {
        cerr<<"Problema van az "<<fname<<" fajllal!\n";
    }
    return 0;
}
*/
