#pragma once
#include <iostream>
#include "library\selection.hpp"
#include "library\maxsearch.hpp"

struct adat{
    std::string date;
    int hom;
    int csap;
    friend std::istream& operator>>(std::istream& inp, adat& e)
    {
        inp>>e.date>>e.hom>>e.csap;
        return inp;
    }
};

//Feltesszk, hogy lesz csapadkos nap
class ElsoCsapadekos : public Selection<adat>
{
protected:
    bool cond(const adat& e) const override {return e.csap>0;}
};

class MinHom : public MaxSearch<adat,int,Less<int>>
{
protected:
    int func(const adat &e) const override { return e.hom; }
    void first() override {}
    bool whileCond(const adat& e) const { return e.csap>0; }

};

//Nem tehet fel, hogy lesz csapadkos nap
class ElsoCsapadekos_lehet_hogy_nincs : public Selection<adat>
{
protected:
    bool cond(const adat& e) const override {return _enor->end() || e.csap>0;}
};
